SystemOrganization addCategory: #ConfigurationOfArtefact!

Object subclass: #ConfigurationOfArtefact
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfArtefact'!

!ConfigurationOfArtefact commentStamp: '<historical>' prior: 0!
(ConfigurationOfArtefact project version: #stable) load


!!!! 2013-08-10 cleaning the configuration

(ConfigurationOfArtefact project version: '1.1') load


!!!! Version 1.0 release
(ConfigurationOfArtefact project version: '1.0') load
!

!ConfigurationOfArtefact class methodsFor: 'development support' stamp: 'GuillaumeLarcheveque 3/8/2013 18:54'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfArtefact class methodsFor: 'private' stamp: 'GuillaumeLarcheveque 3/8/2013 18:54'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfArtefact class methodsFor: 'catalog' stamp: 'StephaneDucasse 8/24/2013 21:14'!
catalogChangeLog

	^ '- Version: 1.1 2013-08-10 cleaning the configuration
[[[	
	(ConfigurationOfArtefact project version: ''1.1'') load
]]]
- Version 1.0 release of Artefact
[[[ 
	(ConfigurationOfArtefact project version: ''1.0'') load
]]]
'! !

!ConfigurationOfArtefact class methodsFor: 'catalog' stamp: 'StephaneDucasse 8/24/2013 20:56'!
catalogDescription

	^ 'Artefact is a library to generate PDF documents. It provides a document model and support the generation of PDF'! !

!ConfigurationOfArtefact class methodsFor: 'catalog' stamp: 'StephaneDucasse 8/24/2013 21:19'!
catalogKeyClassesAndExample

^ '
	==PDFDocument== is a central class that represents a document. 
	
	==PDFDemos== is a class containing many examples. You can execute them all by ==PDFDemos runAllDemos==. It generates all the examples in a folder.
	
	==PDFTemplate== represents the page template. Its subclasses represent some predefined pages format.
	
'! !

!ConfigurationOfArtefact class methodsFor: 'catalog' stamp: 'StephaneDucasse 8/24/2013 21:12'!
catalogKeywords

	^ #(PDF layout document)! !

!ConfigurationOfArtefact class methodsFor: 'private' stamp: 'GuillaumeLarcheveque 3/8/2013 18:54'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfArtefact class methodsFor: 'private' stamp: 'GuillaumeLarcheveque 3/8/2013 18:54'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfArtefact class methodsFor: 'metacello tool support' stamp: 'GuillaumeLarcheveque 3/8/2013 18:54'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfArtefact class methodsFor: 'loading' stamp: 'GuillaumeLarcheveque 3/8/2013 18:54'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfArtefact class methodsFor: 'loading' stamp: 'GuillaumeLarcheveque 3/8/2013 18:54'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfArtefact class methodsFor: 'loading' stamp: 'GuillaumeLarcheveque 3/8/2013 18:54'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfArtefact class methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/8/2013 18:54'!
project

	^self new project! !

!ConfigurationOfArtefact class methodsFor: 'development support' stamp: 'GuillaumeLarcheveque 3/8/2013 18:54'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfArtefact methodsFor: 'baselines' stamp: 'GuillaumeLarcheveque 3/8/2013 18:59'!
baseline09: spec
	<version: '0.9-baseline'>
	spec
		for: #common
		do: [ 
			spec blessing: #baseline.
			spec repository: 'http://www.squeaksource.com/Units'.
			spec
				package: 'Units' with: 'Units-espin.36'.
			spec repository: 'http://smalltalkhub.com/mc/RMoD/Artefact/main'.
			spec
				package: 'Artefact']! !

!ConfigurationOfArtefact methodsFor: 'baselines' stamp: 'GuillaumeLarcheveque 5/17/2013 15:05'!
baseline10: spec
	<version: '1.0-baseline'>
	spec
		for: #common
		do: [ 
			spec blessing: #baseline.
			spec repository: 'http://smalltalkhub.com/mc/MarcusDenker/Units/main'.
			spec
				package: 'Units' with: 'Units-espin.36'.
			spec repository: 'http://smalltalkhub.com/mc/RMoD/Artefact/main'.
			spec
				package: 'Artefact']! !

!ConfigurationOfArtefact methodsFor: 'baselines' stamp: 'TorstenBergmann 9/16/2013 18:04'!
baseline11: spec
	<version: '1.1-baseline'>
	spec
		for: #common
		do: [ 
			spec blessing: #baseline.
			spec author: 'Olivier Auverlot and Guillaume Larcheveque'.
			spec timestamp: '10/08/2013'.
			spec repository:  'http://smalltalkhub.com/mc/RMoD/Artefact/main'.
			
			spec package: 'Artefact' with: [ spec requires: 'Units' ].
			spec
				project: 'Units'
				with: [ 
					spec
						className: 'ConfigurationOfUnits';
						file: 'ConfigurationOfUnits';
						version: '1.0-baseline';
						 repository: 'http://smalltalkhub.com/mc/MarcusDenker/Units/main'] ]! !

!ConfigurationOfArtefact methodsFor: 'baselines' stamp: 'TorstenBergmann 1/10/2014 16:41'!
baseline12: spec
	<version: '1.2-baseline'>
	spec
		for: #common
		do: [ 
			spec blessing: #baseline.
			spec author: 'Torsten Bergmann'.
			spec timestamp: '10/01/2014'.
			spec repository:  'http://smalltalkhub.com/mc/RMoD/Artefact/main'.

			spec project: 'Units'
					with: [ spec
								className: 'ConfigurationOfUnits';
								file: 'ConfigurationOfUnits';
								version: '1.1-baseline';
						 		repository: 'http://smalltalkhub.com/mc/MarcusDenker/Units/main']. 
			
			spec package: 'Artefact-Core' with: [ spec requires: 'Units' ].
			spec package: 'Artefact-Tests' with: [ spec requires: 'Artefact-Core' ].
			spec package: 'Artefact-Examples' with: [ spec requires: 'Artefact-Core' ].
				
			spec 
				group: 'default'       with: #('core' 'tests' 'examples');
				group: 'core'     	with:#('Artefact-Core');
				group: 'tests'     	with:#('Artefact-Tests');
				group: 'examples'   with:#('Artefact-Examples')	].
		 ! !

!ConfigurationOfArtefact methodsFor: 'baselines' stamp: 'StephanEggermont 12/29/2014 00:14'!
baseline13: spec
	<version: '1.3-baseline'>
	spec
		for: #common
		do: [ 
			spec blessing: #baseline.
			spec author: 'Olivier Auverlot'.
			spec timestamp: '24/01/2014'.
			spec repository:  'http://smalltalkhub.com/mc/RMoD/Artefact/main'.

			spec project: 'Units'
					with: [ spec
								className: 'ConfigurationOfUnits';
								file: 'ConfigurationOfUnits';
								version: '1.1-baseline';
						 		repository: 'http://smalltalkhub.com/mc/MarcusDenker/Units/main']. 
			
			spec package: 'Artefact-Core' with: [ spec requires: 'Units' ].
			spec package: 'Artefact-Tests' with: [ spec requires: 'Artefact-Core' ].
			spec package: 'Artefact-Examples' with: [ spec requires: 'Artefact-Core' ].
				
			spec 
				group: 'default'       with: #('core' 'tests' 'examples');
				group: 'core'     	with:#('Artefact-Core');
				group: 'tests'     	with:#('Artefact-Tests');
				group: 'examples'   with:#('Artefact-Examples')	].
	spec
		for: #'pharo2.x'
		do: [ 
			"added 2014-12-29 Stephan Eggermont"
			spec package: 'Artefact-Pharo20'.
			spec package: 'Artefact-Core' with: [ spec requires: #('Units' 'Artefact-Pharo20') ]].
			
! !

!ConfigurationOfArtefact methodsFor: 'baselines' stamp: 'TorstenBergmann 12/30/2014 01:35'!
baseline14: spec
	<version: '1.4-baseline'>
	spec
		for: #common
		do: [ 
			spec blessing: #baseline.
			spec author: 'Olivier Auverlot'.
			spec timestamp: '24/01/2014'.
			spec repository:  'http://smalltalkhub.com/mc/RMoD/Artefact/main'.

			spec project: 'Units'
					with: [ spec
								className: 'ConfigurationOfUnits';
								file: 'ConfigurationOfUnits';
								version: '1.1-baseline';
						 		repository: 'http://smalltalkhub.com/mc/MarcusDenker/Units/main']. 
			
			spec package: 'Artefact-Core' with: [ spec requires: 'Units' ].
			spec package: 'Artefact-Tests' with: [ spec requires: #('Artefact-Core' 'Artefact-Examples' ). ].
			spec package: 'Artefact-Examples' with: [ spec requires: 'Artefact-Core' ].
				
			spec 
				group: 'default'       with: #('core' 'tests' 'examples');
				group: 'core'     	with:#('Artefact-Core');
				group: 'tests'     	with:#('Artefact-Tests');
				group: 'examples'   with:#('Artefact-Examples')	].
	spec
		for: #'pharo2.x'
		do: [ 
			"added 2014-12-29 Stephan Eggermont"
			spec package: 'Artefact-Pharo20'.
			spec package: 'Artefact-Core' with: [ spec requires: #('Units' 'Artefact-Pharo20') ]].
			
! !

!ConfigurationOfArtefact methodsFor: 'baselines' stamp: 'GuillaumeLarcheveque 3/11/2015 16:33'!
baseline15: spec
	<version: '1.5-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/RMoD/Artefact/main'.
		spec 
			project: 'Units' with: [
				spec
					className: #ConfigurationOfUnits;
					versionString: '1.1-baseline';
					repository: 'http://smalltalkhub.com/mc/MarcusDenker/Units/main' ];
			project: 'Stylesheet' with: [
				spec
					className: #ConfigurationOfStylesheet;
					versionString: #'development';
					repository: 'http://smalltalkhub.com/mc/RMoD/Stylesheet/main/' ].
		spec 
			package: 'Artefact-Core' with: [
				spec requires: #('Units' 'Stylesheet' ). ];
			package: 'Artefact-Examples' with: [
				spec requires: #('Artefact-Core' ). ];
			package: 'Artefact-Tests' with: [
				spec requires: #('Artefact-Core' 'Artefact-Examples' ). ].
		spec 
			group: 'default' with: #('core' 'tests' 'examples' );
			group: 'core' with: #('Artefact-Core' );
			group: 'tests' with: #('Artefact-Tests' );
			group: 'examples' with: #('Artefact-Examples' ). ].
! !

!ConfigurationOfArtefact methodsFor: 'baselines' stamp: 'TorstenBergmann 1/30/2017 21:49'!
baseline16: spec
	<version: '1.6-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/RMoD/Artefact/main'.
		spec 
			project: 'Units' with: [
				spec
					className: #ConfigurationOfUnits;
					versionString: '1.1-baseline';
					repository: 'http://smalltalkhub.com/mc/MarcusDenker/Units/main' ];
			project: 'Stylesheet' with: [
				spec
					className: #ConfigurationOfStylesheet;
					versionString: #'development';
					repository: 'http://smalltalkhub.com/mc/RMoD/Stylesheet/main/' ].
		spec 
			package: 'Artefact-Core' with: [
				spec requires: #('Units' 'Stylesheet' ). ];
			package: 'Artefact-Examples' with: [
				spec requires: #('Artefact-Core' ). ];
			package: 'Artefact-Tests' with: [
				spec requires: #('Artefact-Core' 'Artefact-Examples' ). ].
		spec 
			group: 'default' with: #('core' 'tests' 'examples' );
			group: 'core' with: #('Artefact-Core' );
			group: 'tests' with: #('Artefact-Tests' );
			group: 'examples' with: #('Artefact-Examples' ). ].
! !

!ConfigurationOfArtefact methodsFor: 'symbolic versions' stamp: 'GuillaumeLarcheveque 2/25/2015 15:22'!
bleedingEdge: spec
	 <symbolicVersion: #'bleedingEdge'>

	spec for: #'common' version: '1.5-baseline'.
! !

!ConfigurationOfArtefact methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/8/2013 18:54'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfArtefact methodsFor: 'symbolic versions' stamp: 'CyrilFerlicot 5/31/2016 16:19'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.5-baseline'.
! !

!ConfigurationOfArtefact methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/8/2013 18:54'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfArtefact methodsFor: 'accessing' stamp: 'StephaneDucasse 8/10/2013 16:42'!
repositoryUrlString
	^ 'http://smalltalkhub.com/mc/RMoD/Artefact/main'! !

!ConfigurationOfArtefact methodsFor: 'symbolic versions' stamp: 'TorstenBergmann 1/30/2017 12:02'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.5'.
	spec for: #'pharo4.x' version: '1.5'.
	spec for: #'pharo5.x' version: '1.5'.
	spec for: #'pharo6.x' version: '1.6'.
! !

!ConfigurationOfArtefact methodsFor: 'versions' stamp: 'GuillaumeLarcheveque 3/8/2013 19:02'!
version09: spec
	<version: '0.9' imports: #('0.9-baseline')>
	
	spec for: #common do: [
		spec
			blessing: #stable;
			author: 'Olivier Auverlot and Guillaume Larcheveque';
			description: 'configuration for artefact'.
		spec
			package: 'Artefact' with: 'Artefact-GuillaumeLarcheveque.194'.
	]! !

!ConfigurationOfArtefact methodsFor: 'versions' stamp: 'GuillaumeLarcheveque 5/31/2013 15:22'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>
	
	spec for: #common do: [
		spec
			blessing: #stable;
			author: 'Olivier Auverlot and Guillaume Larcheveque';
			description: 'configuration for artefact'.
		spec
			package: 'Artefact' with: 'Artefact-GuillaumeLarcheveque.230'.
	]! !

!ConfigurationOfArtefact methodsFor: 'versions' stamp: 'TorstenBergmann 12/30/2013 10:27'!
version11: spec
	<version: '1.1' imports: #('1.1-baseline')>
	
	spec for: #common do: [
		spec
			blessing: #stable;
			author: 'Olivier Auverlot and Guillaume Larcheveque';
			description: 'Configuration for artefact'.
		spec package: 'Artefact' with: 'Artefact-TorstenBergmann.245'.
		spec project: 'Units' with: '1.1'
	]! !

!ConfigurationOfArtefact methodsFor: 'versions' stamp: 'TorstenBergmann 1/10/2014 16:49'!
version12: spec
	<version: '1.2' imports: #('1.2-baseline')>
	
	spec for: #common do: [
		spec blessing: #release.
		spec author: 'Torsten Bergmann'.
		spec timestamp: '10/01/2014'.
		spec description: 'Split single package into core, tests and examples. Use latest units release and cleanup for upcoming Pharo 3.0'.
			
		spec project: 'Units' with: '1.2'.
		
		spec package: 'Artefact-Core' with: 'Artefact-Core-TorstenBergmann.247'.
		spec package: 'Artefact-Tests' with: 'Artefact-Tests-TorstenBergmann.1'.
		spec package: 'Artefact-Examples' with: 'Artefact-Examples-TorstenBergmann.1'.	
	]! !

!ConfigurationOfArtefact methodsFor: 'versions' stamp: 'OlivierAuverlot 1/24/2014 10:18'!
version13: spec
	<version: '1.3' imports: #('1.3-baseline')>
	
	spec for: #common do: [
		spec blessing: #release.
		spec author: 'Olivier Auverlot'.
		spec timestamp: '24/01/2014'.
		spec description: 'Support of opacity'.
			
		spec project: 'Units' with: '1.2'.
		
		spec package: 'Artefact-Core' with: 'Artefact-Core-OlivierAuverlot.249'.
		spec package: 'Artefact-Tests' with: 'Artefact-Tests-OlivierAuverlot.2'.
		spec package: 'Artefact-Examples' with: 'Artefact-Examples-OlivierAuverlot.2'.	
	]! !

!ConfigurationOfArtefact methodsFor: 'versions' stamp: 'OlivierAuverlot 1/12/2015 08:04'!
version14: spec
	<version: '1.4' imports: #('1.4-baseline')>
	
	spec for: #common do: [
		spec blessing: #release.
		spec author: 'Stephan Eggermont'.
		spec timestamp: '29/12/2014'.
		spec description: 'Make it green'.
			
		spec project: 'Units' with: '1.2'.
		
		spec package: 'Artefact-Pharo20' with: 'Artefact-Pharo20-StephanEggermont.1'.
		spec package: 'Artefact-Core' with: 'Artefact-Core-OlivierAuverlot.259'.
		spec package: 'Artefact-Tests' with: 'Artefact-Tests-OlivierAuverlot.4'.
		spec package: 'Artefact-Examples' with: 'Artefact-Examples-OlivierAuverlot.8'.	
	]! !

!ConfigurationOfArtefact methodsFor: 'versions' stamp: 'CyrilFerlicot 5/31/2016 16:19'!
version15: spec
	<version: '1.5' imports: #('1.5-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.5'.
		spec author: 'CyrilFerlicot'.
		spec timestamp: '5/31/2016 16:19'.
		spec 
			project: 'Units' with: '1.1-baseline';
			project: 'Stylesheet' with: '0.2-baseline'.
		spec 
			package: 'Artefact-Core' with: 'Artefact-Core-CyrilFerlicot.267';
			package: 'Artefact-Examples' with: 'Artefact-Examples-CyrilFerlicot.10';
			package: 'Artefact-Tests' with: 'Artefact-Tests-GuillaumeLarcheveque.6'. ].
! !

!ConfigurationOfArtefact methodsFor: 'versions' stamp: 'TorstenBergmann 1/30/2017 12:03'!
version16: spec
	<version: '1.6' imports: #('1.6-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.6'.
		spec author: 'TorstenBergmann'.
		spec timestamp: '1/30/2017 16:19'.
		spec 
			project: 'Units' with: '1.1-baseline';
			project: 'Stylesheet' with: '0.2-baseline'.
		spec 
			package: 'Artefact-Core' with: 'Artefact-Core-TorstenBergmann.268';
			package: 'Artefact-Examples' with: 'Artefact-Examples-CyrilFerlicot.10';
			package: 'Artefact-Tests' with: 'Artefact-Tests-GuillaumeLarcheveque.6'. ].
! !
